#!/usr/bin/python

# Rauschunterdrueckung mittels Median-Filter
#
# Dieses Programm arbeitet mit Farb-Bildern
#
# GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/

import Image
import sys

imIn = Image
if len( sys.argv ) > 1:
    imIn = Image.open(sys.argv[1])
else:
    print "Missing argument!\n Syntax program-name image-file\n"
    exit(0)

# image dimensions
width, height = imIn.size

# create output image
imOut = Image.new( imIn.mode, (width, height) )

RED = 0; GREEN = 1; BLUE = 2

# iterate over image
for y in range( 1, height-1 ):
    for x in range( 1, width-1 ):

        # generate list of the 3x3 pixel neighborhood
        neighborhood = [ [],  [],  [] ]
        for j in range( -1,  2):
            for i in range( -1,  2):
                color = imIn.getpixel( (x+i, y+j) )
                neighborhood[RED].append( color[RED] )
                neighborhood[GREEN].append( color[GREEN] )
                neighborhood[BLUE].append( color[BLUE] )

        # find median of 9 = 5th smallest value
        neighborhood[RED].sort()
        neighborhood[GREEN].sort()
        neighborhood[BLUE].sort()
        imOut.putpixel( (x, y),  ( neighborhood[RED][4], neighborhood[GREEN][4], neighborhood[BLUE][4] ) );

# display input and output image
imIn.show()
imOut.show()

#vim:expandtab:
