#!/usr/bin/python -O

# Sharpening mittels Laplace-Operator
#
# Dieses Programm arbeitet mit Farb-Bildern.
#
# GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/


import Image
import sys

imIn = Image
if len( sys.argv ) > 1:
    imIn = Image.open(sys.argv[1])
else:
    print "Missing argument!\n Syntax program-name image-file\n"
    exit(0)

# image dimensions
width,  height = imIn.size

# create output image
imOut = Image.new( imIn.mode,  (width, height) )

RED = 0; GREEN = 1; BLUE = 2

# mask = Identity - Laplace
# -> Image * mask = Image - Laplace(image)
filter_kernel= [ [0,  -1,  0],  [-1,  5,  -1],  [0,  -1,  0] ]

# iterate over image
for y in range( 1, height-1 ):
    for x in range( 1, width-1 ):

        color_out = [0, 0, 0];
        for j in range( -1,  2):
            for i in range( -1,  2):
                color_in = imIn.getpixel( (x+i, y+j) )
                # correlation
                color_out[RED]   += color_in[RED]   * filter_kernel[i][j]
                color_out[GREEN] += color_in[GREEN] * filter_kernel[i][j]
                color_out[BLUE]  += color_in[BLUE]  * filter_kernel[i][j]

        # clamp values to [0,255]
        for c in (RED,GREEN,BLUE):
            color_out[c] = min( 255, max( color_out[c], 0 ) )

        imOut.putpixel( (x, y), tuple(color_out) )       # write result to output image

# display input and output image
imIn.show()
imOut.show()


#vim:expandtab:

