#!/usr/bin/python

# Wie Sierpinski.py, aber mit Tuple und Dictionary
# Noch schoener waere es natuerlich mit einer eigenen 2D-Punkt-Klasse
#
# GZ 2011, TU Clausthal, http://zach.in.tu-clausthal.de/cg_in_schule/


import Image
import random
import sys

im = Image.new("RGB", (512, 512), (256, 256, 256) )

if len(sys.argv) > 1:
    N = int( sys.argv[1] )
else:
    N = 1000

vertex = { "r" : (0.0,0.0),     # dictionary of coords of vertices
           "g" : (512.0,0.0),
           "b" : (256.0,443.4)
         }
x0, y0 = 0.0, 0.0               # start at "red" vertex

for i in range( 0, N ):
        r = random.random()

        if r < 0.333:
            x1, y1 = vertex["r"]
        elif r < 0.6667:
            x1, y1 = vertex["g"]
        else:
            x1, y1 = vertex["b"]

        x0 = ( x1 + x0 ) / 2.0
        y0 = ( y1 + y0 ) / 2.0

        im.putpixel ( (int(x0), int(y0)), (int(x0), int(y0), 0) )
        
im.show()


#vim:expandtab:
